<?

/*
 * FlatImageGallery
 * Copyright (C) 2004-2005 Marco Segato
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the license, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 */

/*
 * Blocco per FlatNuke (http://flatnuke.sourceforge.net) di Simone Vellei che
 * permette di creare automaticamente una galleria di immagini a partire da
 * quelle che ci sono nella directory dove e' presente questo file.
 *
 * Autore    Marco Segato  <segatom@yahoo.it>
 * Website   http://www.marcosegato.tk
 * Versione  0.4.2
 * Data      06/06/2005
 */

/**
 * Funzioni del modulo FlatImageGallery
 *
 * Le funzioni presenti in questo modulo di {@link http://www.flatnuke.org FlatNuke}
 * permettono di creare automaticamente una galleria di immagini.
 *
 * @package Funzioni_di_sistema
 *
 * @author Marco Segato <segatom@yahoo.it> {@link http://www.marcosegato.tk}
 * @version 0.4.1 - 06/06/2005
 * @copyright Copyright (c) 2004-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */

/**
 * Genera l'anteprima di un'immagine
 *
 * Richiamata su un'immagine, ne genera un'anteprima in formato PNG.
 *
 * @author Marco Segato <segatom@yahoo.it>
 * @since 2.5
 *
 * @param string $image Percorso dell'immagine relativo alla root
 * @param string $thumbsize Dimensione massima (px) dell'anteprima da realizzare
 */
function create_thumbnail($image, $thumbsize)
	{ $size = getimagesize($image);

	switch ($size[2])
		{ case 1:
			$tmb = ImageCreateFromGif($image);
		break;
		case 2:
			$tmb = ImageCreateFromJpeg($image);
		break;
		case 3:
			$tmb = ImageCreateFromPng($image);
		break;
		default:
			$size[0] = $size[1] = 150;
			$tmb = ImageCreateTrueColor(150,150);
			$rosso = ImageColorAllocate($tmb,255,0,0);
			ImageString($tmb,5,10,10,"Not a valid",$rosso);
			ImageString($tmb,5,10,30,"GIF, JPEG or PNG",$rosso);
			ImageString($tmb,5,10,50,"image.",$rosso);
		}

	if($size[0]<$thumbsize and $size[1]<$thumbsize)
		{ $new_w = $size[0];
		$new_h = $size[1];
		}
	else if($size[0]>$size[1])
		{ $new_w = $thumbsize;
		$new_h = $thumbsize * $size[1] / $size[0];
		}
		else 	{ $new_w = $thumbsize * $size[0] / $size[1];
			$new_h = $thumbsize;
			}

	$print_tmb = ImageCreateTrueColor($new_w,$new_h);

	// gestione trasparenze
	$trasparenza = imagecolorallocate($print_tmb, 256, 256, 256);
	imagefill($print_tmb, 0, 0, $trasparenza);
	imagecolortransparent($print_tmb, $trasparenza);

	ImageCopyResized($print_tmb,$tmb,0,0,0,0,$new_w,$new_h,ImageSX($tmb),ImageSY($tmb));

	header("Content-type: image/png");
	imagepng($print_tmb);
	imagedestroy($print_tmb);
	}

if(file_exists($_GET['image']) and !stristr($_GET['image'],"..") and (file_exists(dirname($_GET['image'])."/gallery")))
	{ // imposto memoria (limitatamente a questo script) a 20mb per
	// superare settaggio di default nelle installazioni di PHP che  8mb
	ini_set ("memory_limit","20M");
	create_thumbnail($_GET['image'],$_GET['hw']);
	}

?>
